SystemOrganization addCategory: #ConfigurationOfEpigentRiakInterface!

Object subclass: #ConfigurationOfEpigentRiakInterface
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfEpigentRiakInterface'!

!ConfigurationOfEpigentRiakInterface class methodsFor: 'private' stamp: 'RunarJordahl 2/16/2011 20:26'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'private' stamp: 'RunarJordahl 2/16/2011 20:26'!
ensureMetacello
	"Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
	 Gofer API), then load the latest version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [ | error |
		"list of repositories to try, in case primary repository is not accessible"
		(Array 
			with: 'http://www.squeaksource.com/MetacelloRepository' 
			with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
				([
					Smalltalk at: #Gofer ifAbsent: [
					"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
						self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
					Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
						gofer := goferClass new
							url: repositoryUrl;
							yourself.
						[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
						gofer load ]]
							on: Error
							do: [ :ex |
								error := ex.
								Transcript 
									cr; 
									show: 'failed ensureMetacello: ';
									show: ex description printString;
									show: '...retrying'.
								"try again"
								ex return: nil ]) ~~ nil
					ifTrue: [
						"load 'default' group of Metacello"
						(Smalltalk at: #ConfigurationOfMetacello) perform: #load.
						^self ]].
		"shouldn't get here unless the load failed ... throw an error"
		self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'metacello tool support' stamp: 'RunarJordahl 2/16/2011 20:26'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'metacello tool support' stamp: 'RunarJordahl 2/16/2011 20:26'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'loading' stamp: 'RunarJordahl 2/16/2011 20:26'!
load
	"self load"

	^self project stableVersion load! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'metacello tool support' stamp: 'RunarJordahl 2/16/2011 20:26'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'accessing' stamp: 'RunarJordahl 2/16/2011 20:26'!
project

	^self new project! !

!ConfigurationOfEpigentRiakInterface class methodsFor: 'unloading Metacello' stamp: 'RunarJordahl 2/16/2011 20:26'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfEpigentRiakInterface methodsFor: 'accessing' stamp: 'RunarJordahl 2/16/2011 21:48'!
baseline0_1: spec
	<version: '0.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://www.squeaksource.com/EpigentRiakInterface'.
			spec
				package: 'EpigentRiakInterface-Core'";
				package: 'EpigentRiakInterface-Tests' with: [ spec requires: 'EpigentRiakInterface-Core' ]" ]! !

!ConfigurationOfEpigentRiakInterface methodsFor: 'accessing' stamp: 'RunarJordahl 2/16/2011 20:26'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfEpigentRiakInterface methodsFor: 'accessing' stamp: 'RunarJordahl 2/16/2011 21:50'!
version0_1: spec
	<version: '0.1' imports: #('0.1-baseline')>
	spec
		for: #common
		do: [ 
			spec
				package: 'EpigentRiakInterface-Core' with: 'EpigentRiakInterface-RunarJordahl.10';
				package: 'EpigentRiakInterface-Tests' with: 'EpigentRiakInterface-RunarJordahl.10' ]! !
